<template>
  <div class="box flex flex-col md:flex-row min-h-[500px] divide-x divide-y">
  <!-- Sidebar Navigation -->
  <div class="bg-gray-50 rounded-xl p-3 flex gap-3 flex-row md:flex-col w-full md:w-40 overflow-x-auto scrollbar-thin scrollbar-thumb-orange-200 scrollbar-track-orange-50">
    <button v-for="tab in tabs" @click="() => {
      filterForm.page = tab
      filterForm.get(`/employee/user/${user.id}`);
    }" class="block p-2 rounded text-base md:text-md flex-shrink-0 w-full md:w-auto"
      :class="tab === page ? 'bg-[#C59D5F] hover:bg-[#C59D5F] text-white font-semibold' : 'bg-gray-200 hover:bg-gray-300'">
      {{ tab }}
    </button>
  </div>

  <!-- Main Content Area -->
  <div class="flex-1 divide-y">
    <!-- Page Title -->
    <div class="text-xl md:text-2xl text-gray-500 font-bold p-2 text-center bg-gray-50">
      <span>{{ page.toUpperCase() }}</span>
      <div class="flex items-center">
        <span class="text-base mr-2">{{ user.name }}</span>
        <a :href="`/employee/user/${user.id}/download`" class="text-gray-500 text-base">
          <Icon icon="fa-solid fa-download"></Icon>
        </a>
      </div>
    </div>

    <!-- Page Content -->
    <div>
      <!-- Profile Page -->
      <div v-if="page === 'Profile'" class="flex flex-col md:flex-row gap-10 md:gap-0 px-3 py-10">
        <!-- Profile Picture and Basic Info -->
        <div class="flex-1 text-center md:text-left">
          <div class="flex flex-col items-center md:items-start">
            <div class="w-56 h-56 relative">
              <img class="rounded-full border-gray-600 w-full h-full object-cover" :class="{ 'border': !user.profile_picture }" :src="user.profile_picture ? user.profile_picture.src : `/user.jpeg`">
            </div>
            <p class="mt-3"><strong>{{ user.name }}</strong></p>
            <p>{{ user.role.name }}</p>
          </div>
        </div>

        <!-- Detailed Info -->
        <div class="flex-1 flex flex-col md:block items-center md:items-start">
          <div class="space-y-10 w-full">
            <!-- Basic Info Section -->
            <div class="text-base">
              <h3 class="mb-2 text-xl text-gray-500">
                <Icon icon="fa-solid fa-user" class="mr-2" />Basic Info
              </h3>
              <p>Name: {{ user.name }}</p>
              <p>CID: {{ user.cid }}</p>
              <p>Email: {{ user.email }}</p>
            </div>

            <!-- Job Info Section -->
            <div class="text-base">
              <h3 class="mb-2 text-xl text-gray-500">
                <Icon icon="fa-solid fa-briefcase" class="mr-2" />Job
              </h3>
              <p>DOJ: {{ user.doj }}</p>
            </div>

            <!-- Roles Section -->
            <div class="text-base">
              <h3 class="mb-2 text-xl text-gray-500">
                <Icon icon="fa-solid fa-street-view" class="mr-2" />Roles
              </h3>
              <p>Role type: {{ user.role.name }}</p>
              <p v-if="user.department">Department Head For: {{ user.department.name }}</p>
              <p v-if="user.department_staff_detail">Department: {{ user.department_staff_detail?.department.name }}</p>
              <p v-if="user.department_staff_detail">Designation: {{ user.department_staff_detail?.designation }}</p>
            </div>
          </div>
        </div>
      </div>

      <!-- Role Page -->
      <div v-else-if="page === 'Role'" class="p-3">
        <div class="text-gray-500 font-semibold">
          <Icon icon="fa-solid fa-user"></Icon>
          {{ user.role.name }} Details
        </div>
        <div class="mt-5 text-base space-y-3">
          <div v-for="frf in frfs">
            <template v-if="frf.role_field.field.type !== 'File'">
              <div v-if="frf.role_field.field.type === 'Checkbox'">
                <span class="font-bold text-gray-500">{{ frf.role_field.field.name }}:</span>
                <span v-for="(so, index) in frf.selected_options">{{ so.value }}<span v-if="index !== frf.selected_options.length - 1">,</span></span>
              </div>
              <div v-else-if="frf.role_field.field.type === 'Text Area'">
                <span class="font-bold text-gray-500">{{ frf.role_field.field.name }}</span> {{ frf.value }}
                <textarea :value="frf.value" class="block textarea-disabled w-full" disabled></textarea>
              </div>
              <div v-else-if="frf.role_field.field.type === 'Date'">
                <span class="font-bold text-gray-500">{{ frf.role_field.field.name }}:</span> {{ frf.value }}
                <span>
                  <Icon class="text-gray-500" icon="fa-solid fa-calendar"></Icon>
                  {{ frf.date_value }}
                </span>
              </div>
              <div v-else>
                <span class="font-bold text-gray-500">{{ frf.role_field.field.name }}:</span> {{ frf.value }}
              </div>
            </template>
          </div>
        </div>
      </div>

      <!-- Balance Page -->
      <div v-else-if="page === 'Balance'" class="p-3">
        <div class="text-gray-500 font-semibold">
          User Leave Balance
        </div>
        <div class="mt-5 text-base space-y-3">
          <div v-for="balance in user.balances">
            <span class="italic">{{ balance.leave_type.type }}</span>:
            <span class="font-bold">{{ balance.balance }}</span>
            <button v-if="balance.leave_type.carry_forward && currentUser.role.update_user" @click="() => {
              dialogBalance.showModal()
              currentLB = balance
              balanceForm.balance = user.carry_forward_starting_balances[balance.leave_type.id] ?? null
            }" type="button" class="ml-2 text-base italic text-gray-500">
              <Icon icon="fa-solid fa-pen-to-square" class="mr-1"></Icon>
            </button>
          </div>
        </div>
      </div>

      <!-- Document Page -->
      <div v-else-if="page === 'Document'" class="p-3">
        <div class="text-gray-500 font-semibold">
          Staff Documents
        </div>
        <div class="mt-5 text-base space-y-3">
          <div v-for="frf in frfs">
            <div v-if="frf.role_field.field.type === 'File'">
              <span class="font-bold text-gray-500">{{ frf.role_field.field.name }}:</span>
              <span v-if="frf.file">
                <Icon icon="fa-solid fa-file" class="text-gray-500"></Icon>
              </span>
              <span v-else class="italic">Empty</span>
              <a :href="frf.file?.src" v-if="frf.file" class="block italic text-sm text-gray-500">
                <Icon icon="fa-solid fa-download"></Icon> Download
              </a>
            </div>
          </div>
        </div>
      </div>

      <!-- Form Page -->
      <div v-else-if="page === 'Form'" class="p-3">
        <div class="text-gray-500 font-semibold">
          Staff Forms
        </div>
        <div class="mt-5 text-base space-y-3">
          <div v-for="ff in user.filled_forms">
            <span class="font-bold text-gray-500">
              <Icon icon="fa-solid fa-clipboard"></Icon>
              {{ ff.raised_form.name }}:
            </span>
            <span v-if="ff.submitted">
              Filled Out!
            </span>
            <span v-else class="italic text-blue-400">On Pending</span>
            <div v-if="ff.submitted" class="flex gap-10">
              <Link :href="`/employee/user/${user.id}/filledForm/${ff.id}`" class="block italic text-sm text-gray-500">
                <Icon icon="fa-solid fa-eye" class="mr-1"></Icon>View form
              </Link>
              <button @click="() => {
                dialog.showModal()
                currentFF = ff
              }" type="button" class="block text-sm italic text-gray-500">
                <Icon icon="fa-solid fa-share-from-square" class="mr-1"></Icon>Share
              </button>
            </div>
          </div>
        </div>
      </div>

      <!-- Performance Page -->
      <div v-else-if="page === 'Performance'" class="p-3">
        <div class="flex flex-col md:flex-row gap-5">
          <!-- Appreciation Notes -->
          <details class="flex-1" open>
            <summary class="text-lime-500 font-semibold select-none">Appreciation Notes</summary>
            <div class="space-y-3 mt-3">
              <Link :href="`/employee/user/${user.id}/observationNote/${on.id}`" v-for="(on, index) in user.observation_notes_as_subject.filter(on => on.type === 'Appreciation Note')" class="ml-5 text-sm text-gray-500 block">
                <span class="font-bold">{{ index + 1 }}.</span> Evaluated by {{ on.observer.name }} ({{ on.observer.role.name }}) on {{ new Date(on.created_at).toLocaleDateString() }}
              </Link>
            </div>
          </details>

          <!-- Incident Reports -->
          <details class="flex-1" open>
            <summary class="text-red-600 font-semibold select-none">Incident Reports</summary>
            <div class="space-y-3 mt-3">
              <Link :href="`/employee/user/${user.id}/observationNote/${on.id}`" v-for="(on, index) in user.observation_notes_as_subject.filter(on => on.type === 'Incident Report')" class="ml-5 text-sm text-gray-500 block">
                <span class="font-bold">{{ index + 1 }}.</span> Evaluated by {{ on.observer.name }} ({{ on.observer.role.name }}) on {{ new Date(on.created_at).toLocaleDateString() }}
              </Link>
            </div>
          </details>
        </div>
      </div>
    </div>
  </div>
</div>

<!-- Dialog Share Form -->
<dialog id="dialog" ref="dialog" class="box p-3 w-full md:w-[600px] h-full">
  <form v-if="currentFF" class="flex flex-col h-full" @submit.prevent="form.put(`/form/sharedForm/${currentFF.id}`, {})">
    <div class="font-semibold text-gray-700">
      <Icon icon="fa-solid fa-share-from-square" class="mr-2"></Icon>
      <label>Share Form</label>
    </div>
    <hr class="my-2 border-gray-200">

    <div class="mb-5">
      <div class="text-base">Form shared with</div>
      <div v-if="currentFF.shared_users.length > 0">
        <div v-for="user in currentFF.shared_users" class="text-base text-gray-500">
          <Icon icon="fa-solid fa-user"></Icon>
          {{ user.name }} ({{ user.role.name }})
        </div>
      </div>
      <div v-else class="border-2 border-dashed flex justify-center items-center h-20 text-sm text-gray-500">
        No Users!
      </div>
    </div>
    <div>
      <div class="text-base">Select users to share form with</div>
      <multiselect v-model="form.users" :multiple="true" :options="users.filter((user) => !currentFF.shared_users.some((u) => u.id === user.id))" label="name" track-by="id" :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
      </multiselect>
      <div class="text-error" v-if="form.errors.users">
        {{ form.errors.users }}
      </div>
    </div>

    <div class="flex-1"></div>
   

    <div class="flex justify-end gap-3 mt-5">
      <button type="button" @click="() => {
        dialog.close();
        form.users = [];
      }" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">
        Close
      </button>
      <button class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">
        Save
      </button>
    </div>
  </form>
</dialog>

<!-- Dialog Carry Forward Leave Balance -->
<dialog id="dialogBalance" ref="dialogBalance" class="box p-3 w-full md:w-[600px]">
  <form v-if="currentLB" class="flex flex-col h-full" @submit.prevent="balanceForm.transform((data) => ({
    ...data,
    id: currentLB.leave_type.id,
  })).put(`/employee/user/${user.id}/startingBalance`)">
    <div class="font-semibold text-gray-700">
      <Icon icon="fa-solid fa-pen-to-square" class="mr-2"></Icon>
      <label>Set starting balance for {{ currentLB.leave_type.type }}</label>
    </div>
    <hr class="my-2 border-gray-200">

    <div class="mb-5">
      <div class="text-base">Starting Balance</div>
      <input class="input w-full" type="number" step="0.01" placeholder="Enter starting balance" v-model="balanceForm.balance" />
      <div v-if="balanceForm.errors.balance" class="text-error">
        {{ balanceForm.errors.balance }}
      </div>
    </div>

    <div class="flex justify-end gap-3 mt-5">
      <button type="button" @click="() => {
        dialogBalance.close();
        balanceForm.balance = null;
      }" class="btn orange">
        Close
      </button>
      <button class="btn green">
        Save
      </button>
    </div>
  </form>
</dialog>
</template>

<script setup>
import { Link, useForm, usePage } from '@inertiajs/vue3';
import { computed, ref, watch } from 'vue';

const dialog = ref(null);
const dialogBalance = ref(null);
const currentFF = ref(null);
const currentLB = ref(null);

const props = defineProps({
  user: Object,
  page: String,
  users: Array
})

const pagex = usePage();
const currentUser = computed(() => pagex.props.currentUser)

watch(() => pagex.props, (value) => {
  if (value.flash.success) {
    dialog.value?.close();
    form.users = [];

    dialogBalance.value?.close();
    balanceForm.balance = null;
  }
})

const filterForm = useForm({
  page: props.page
});

const form = useForm({
  users: []
});

const balanceForm = useForm({
  balance: null
});

const frfs = computed(() => props.user.filled_role_fields?.sort((frfA, frfB) => frfA.role_field.field.index - frfB.role_field.field.index))

const tabs = ['Profile', 'Role', 'Balance', 'Document', 'Form', 'Performance']
</script>